/***************************************************************************\
  "statement.hpp" - Intermediate Code Statement (Phase D)
  Revision 15; 10 Nov 2002 - 15 March 2004
  Copyright (C) 2002-2004  Kevin P. Albrecht
\***************************************************************************/

#ifndef STATEMENT_HPP
#define STATEMENT_HPP

/////////////////////////
// DEFINES //////////////
/////////////////////////

/////////////////////////
// INCLUDES /////////////
/////////////////////////

// Standard //

// Local //

/////////////////////////
// DECLARATIONS /////////
/////////////////////////

typedef enum
{
  tt__Buffer, // fake instruction to print inputbuffer line
  ttColon,

  ttNOP, ttCALL, ttRET, ttSTOP,
  ttJMP, ttJT, ttJF,
  ttEQ, ttNEQ, ttLT, ttGT, ttLTEQ, ttGTEQ,
  ttOR, ttAND, ttNOT,
  ttDB, ttDI, ttDR, ttDS,
  ttTOB, ttTOI, ttTOS, ttTOR,
  ttCIN, ttCOUT,
  ttFIO_OR, ttFIO_OW, ttFIO_C, ttFIO_R, ttFIO_W, ttFIO_EOF,
  ttRAND, ttASC, ttNEG, ttCAT, 
  ttADDI, ttSUBI, ttMULI, ttDIVI, ttPOWI, ttMODI, 
  ttADDR, ttSUBR, ttMULR, ttDIVR, ttPOWR, ttMODR, 
  ttCOPY, ttSWAP,
  ttPOP, ttPOPL, ttPOPP,
  ttPUSH, ttPUSHL, ttPUSHP, 
  ttDBGON, ttDBGLINE, ttDBGFILE
} OpCode;

char *gvsOpCodeStrings[] =
{
  "<buffer>", // fake instruction to print inputbuffer line
  ":",

  "nop", "call", "ret", "stop",
  "jmp", "jt", "jf",
  "eq", "neq", "lt", "gt", "lteq", "gteq",
  "or", "and", "not",
  "db", "di", "dr", "ds",
  "tob", "toi", "tos", "tor",
  "cin", "cout",
  "fio_or", "fio_ow", "fio_c", "fio_r", "fio_w", "fio_eof",
  "rand", "asc", "neg", "cat",
  "addi", "subi", "muli", "divi", "powi", "modi", 
  "addr", "subr", "mulr", "divr", "powr", "modr", 
  "copy", "swap",
  "pop", "popl", "popp",
  "push", "pushl", "pushp",
  "dbgon", "dbgline", "dbgfile"
};

class Statement
{
  public:
    Statement (OpCode aOp, Symbol *aSym);
    ~Statement ();

    OpCode op;
    Type type;
    Symbol *sym;
};

/////////////////////////
// DEFINITIONS //////////
/////////////////////////

Statement::Statement (OpCode aOp, Symbol *aSym)
{
  op = aOp;
  sym = aSym;
}

Statement::~Statement ()
{
  // NOTE: Symbols are not deleted here; they are deleted in   //
  //       scope_deinit() by way of scope_add_symbol_to_list() //
}

#endif
